__kernel void multiply(__global unsigned char *res, __global unsigned char *a, __global unsigned char *b, unsigned long size, __local unsigned char *shmem) {
    unsigned char sum = 0;

    int k;
    int i = get_global_id(1);
    int j = 4 * get_global_id(0);
    
    __global unsigned char *res0 = &res[i * size + j];
    __global unsigned char *a0 = &a[i * size + j];
    __global unsigned char *b0 = &b[i * size + j];

    for (k = 0; k < 4; k++) {
	res0[k] = abs(a0[k] - b0[k]);
    }

}
