__kernel void multiply(__global unsigned char *res, __global unsigned char *a, __global unsigned char *b, unsigned long size, __local unsigned char *shmem) {
    unsigned char sum = 0;

    int k;
    int i = get_global_id(1);
    int j = 4 * get_global_id(0);
    
//    __global unsigned char *res0 = &res[i * size + j];

    unsigned res0;
    unsigned a0 = *(__global unsigned*)&a[i * size + j];
    unsigned b0 = *(__global unsigned*)&b[i * size + j];

    
    asm("vabsdiff4.u32.u32.u32 %0, %1, %2, %0;" : "=r"(res0) : "r"(a0), "r"(b0));

    *(__global unsigned*)&res[i * size + j] = res0;

/*
    for (k = 0; k < 4; k++) {
	res0[k] = abs(a0[k] - b0[k]);
    }
*/
}
