#include <stdio.h>
#include <stdlib.h>

int exercise_init(const char *name, size_t size) {
    return 0;
}

int exercise_allocate(float **res, float **a, float **b, size_t size) {
    return 0;
}

void exercise_free() {
}

int exercise_required_alignment = 0;



static void exercise_iteration(float *res, float *a, float *b, size_t size) {
    int i, j, k;
    
    #pragma acc kernels present_or_copyin(a[0:size*size],b[0:size*size])  copyout(res[0:size*size])
    {
	#pragma acc loop independent
	for(i = 0;i < size;i++) {
	    #pragma acc loop independent
	    for(j = 0;j < size;j++) {
		res[i * size +j] = 0;
		for(k = 0;k < size; k++) {
		    res[i * size + j] += a[i * size + k] * b[k * size + j];
		}
	    }
	}
    } 
}

size_t exercise(float *res, float *a, float *b, size_t size, int iterations) {
    long iter;

    for (iter = 0; iter < iterations; iter++) {
	exercise_iteration(res, a, b, size);
    }
    return 0;
}
