#include <stdio.h>
#include "mkl_types.h"
#include "mkl_cblas.h"

int exercise_init(const char *name, size_t size) {
    return 0;
}

int exercise_allocate(float **res, float **a, float **b, size_t size) {
    return  0;
}

void exercise_free() {
}

int exercise_required_alignment = 0;

size_t exercise(float *res, float *a, float *b, size_t size, int iterations) {
    long i;

    float alpha = 1, beta = 0;
    CBLAS_TRANSPOSE transA = CblasNoTrans, transB = CblasNoTrans, order = CblasRowMajor;

    for (i = 0; i < iterations; i++) {
        cblas_sgemm(order, transA, transB, size, size, size, alpha,
                  a, size, b, size, beta, res, size);
    }

    return 0;
}
