__kernel void transpose(__global float *res, __global float *a, unsigned long size, __local float *shmem) {
    int i = get_global_id(1);
    int j = get_global_id(0);

    res[j * size + i] = a[i * size + j];
}
