__kernel void multiply(__global float *res, __global float *a, __global float *b, unsigned int size, __global float *gmem, __local float *lmem) {
    int i;
    float sum = 0;
    
    if (get_global_id(0) == 0) {
        for(i = 0; i < size; i++) {
	    sum  += a[i] * b[i];
        }
        *res = sum;
    }
}
