#include "random123/threefry.h"

#define rnd_init(a) \
    threefry4x32_key_t k = {{a, 0xdecafbad, 0xfacebead, 0x12345678}}; \
    threefry4x32_ctr_t c = {{0, 0xf00dcafe, 0xdeadbeef, 0xbeeff00d}};

#define rnd(a, b) \
    { \
	union { \
	    threefry4x32_ctr_t c; \
	    int4 i; \
	} u; \
	c.v[0]++; \
	u.c = threefry4x32(c, k); \
	float4 res = convert_float4(u.i) / ((unsigned int)0x7FFFFFFF); \
	a.x = res.x; a.y = res.y; b.x = res.z; b.y = res.w; \
    }

__kernel void pi(__global unsigned long *res, unsigned long n, __global unsigned long *gmem, __local unsigned long *lmem) {
    unsigned long hits = 0, i;
    
    rnd_init(get_global_id(0))

    for(i = 0; i < n; i+=2) {
	float2 a, b;
	rnd(a, b);


    }


    *res = hits;
}
