__kernel void multiply(__global float *res, __global float *a, __global float *b, unsigned long size, __local float *shmem) {
    float sum = 0;

    int i = get_global_id(1);
    int j = get_global_id(0);
    int k;

    for(k = 0; k < size; k++) {
	sum  += a[i * size + k] * b[k * size + j];
    }
    
    res[i * size +j] = sum;
}
