__kernel void multiply(__global unsigned char *res, __global unsigned char *a, __global unsigned char *b, unsigned long size, __local unsigned char *shmem) {
    unsigned char sum = 0;

    int i = get_global_id(1);
    int j = get_global_id(0);
    
    res[i * size +j] = abs(a[i * size + j] - b[i * size + j]);
}
